package com.youpe.test.event;

import com.youpe.test.networking.ModNetworkingManager;
import com.youpe.test.server.PlayerData;
import com.youpe.test.server.StateSaverAndLoader;
import net.fabricmc.fabric.api.client.networking.v1.ClientPlayNetworking;
import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.fabricmc.fabric.api.networking.v1.PacketByteBufs;
import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.network.PacketByteBuf;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import org.jetbrains.annotations.Nullable;

public class DirtBrokenAfter implements PlayerBlockBreakEvents.After {

    @Override
    public void afterBlockBreak(World world, PlayerEntity player, BlockPos pos, BlockState state, @Nullable BlockEntity blockEntity) {
        if (state.getBlock() == Blocks.GRASS_BLOCK || state.getBlock() == Blocks.DIRT) {

            MinecraftServer server = world.getServer();
            StateSaverAndLoader serverState = StateSaverAndLoader.getServerState(server);
            // Increment the amount of dirt blocks that have been broken
            serverState.totalDirtBlocksBroken += 1;

            PlayerData playerState = StateSaverAndLoader.getPlayerState(player);
            playerState.dirtBlocksBroken += 1;

            // Send a packet to the client


            PacketByteBuf data = PacketByteBufs.create();
            data.writeInt(serverState.totalDirtBlocksBroken);
            data.writeInt(playerState.dirtBlocksBroken);

            ServerPlayerEntity playerEntity = server.getPlayerManager().getPlayer(player.getUuid());

            server.execute(() -> {
                ServerPlayNetworking.send(playerEntity, ModNetworkingManager.DIRT_BROKEN, data);
            });
        }
    }
}
