package com.youpe.test.event;


import com.youpe.test.networking.ModNetworkingManager;
import com.youpe.test.server.PlayerData;
import com.youpe.test.server.StateSaverAndLoader;
import net.fabricmc.fabric.api.networking.v1.PacketByteBufs;
import net.fabricmc.fabric.api.networking.v1.PacketSender;
import net.fabricmc.fabric.api.networking.v1.ServerPlayConnectionEvents;
import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import net.minecraft.network.PacketByteBuf;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.network.ServerPlayNetworkHandler;

public class JoinServerHandler implements ServerPlayConnectionEvents.Join {


    @Override
    public void onPlayReady(ServerPlayNetworkHandler handler, PacketSender sender, MinecraftServer server) {
        PlayerData playerState = StateSaverAndLoader.getPlayerState(handler.getPlayer());
        PacketByteBuf data = PacketByteBufs.create();
        data.writeInt(playerState.dirtBlocksBroken);
        data.writeInt(playerState.level);
        data.writeFloat(playerState.exp);
        data.writeFloat(playerState.strength);
        data.writeFloat(playerState.dexterity);
        data.writeFloat(playerState.intelligence);
        data.writeString(playerState.className);
        server.execute(() -> {
            ServerPlayNetworking.send(handler.getPlayer(), ModNetworkingManager.INIT_SYNC, data);
        });
    }
}
