package com.youpe.test.event;

import com.mojang.blaze3d.systems.RenderSystem;
import com.youpe.test.Testing;
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback;
import net.minecraft.client.gui.DrawContext;
import net.minecraft.client.render.*;
import net.minecraft.util.Identifier;
import org.joml.Matrix4f;

public class TestHudRender {

    private static void addTestRendering(DrawContext drawContext, float tickDelta){
        Matrix4f positionMatrix = drawContext.getMatrices().peek().getPositionMatrix();
        Tessellator tessellator = Tessellator.getInstance();
        BufferBuilder buffer = tessellator.getBuffer();

        buffer.begin(VertexFormat.DrawMode.QUADS, VertexFormats.POSITION_COLOR_TEXTURE);
        buffer.vertex(positionMatrix, 20, 20, 0).color(1f, 1f, 1f, 1f).texture(0f, 0f).next();
        buffer.vertex(positionMatrix, 20, 60, 0).color(1f, 0f, 0f, 1f).texture(0f, 1f).next();
        buffer.vertex(positionMatrix, 60, 60, 0).color(0f, 1f, 0f, 1f).texture(1f, 1f).next();
        buffer.vertex(positionMatrix, 60, 20, 0).color(0f, 0f, 1f, 1f).texture(1f, 0f).next();

        RenderSystem.setShader(GameRenderer::getPositionColorTexProgram);
        RenderSystem.setShaderTexture(0, new Identifier("testing", "icon.png"));
        RenderSystem.setShaderColor(1f, 1f, 1f, 1f);

        tessellator.draw();
    }


    public static void registerModRenders(){
        Testing.LOGGER.info("Registering ModRenders for " + Testing.MOD_ID);
        HudRenderCallback.EVENT.register(TestHudRender::addTestRendering);
    }
}
