package com.youpe.test.item;

import com.youpe.test.Testing;
import com.youpe.test.item.custom.CustomItem;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroupEntries;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroups;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;
import net.minecraft.util.Rarity;

public class ModItems {

    // Items list
    public static final Item CUSTOM_ITEM_EXAMPLE = registerItem("custom_item_example",
            new CustomItem(new FabricItemSettings().rarity(Rarity.EPIC)));

    // Adding to specific ItemGroup (using ItemGroupsEvents)
    public static void addItemsToBuildingBlocks(FabricItemGroupEntries entries){
        entries.add(CUSTOM_ITEM_EXAMPLE);
    }

    // Register item via Registry
    private static Item registerItem(String name, Item item){
        return Registry.register(Registries.ITEM, new Identifier(Testing.MOD_ID, name), item);
    }

    // Using in class which implementing ModInitializer
    public static void registerModItems(){
        Testing.LOGGER.info("Registering Mod Items for " + Testing.MOD_ID);

        ItemGroupEvents.modifyEntriesEvent(ItemGroups.BUILDING_BLOCKS).register(ModItems::addItemsToBuildingBlocks);

    }

}
